package stastro

import (
	"math"

	"gitlab.com/solsw/TurboPower/SysTools/internal/common"
)

func _GetLongitudeUranus(Tau, Tau2, Tau3, Tau4, Tau5 float64) float64 {
	L0 := 5.48129294300 * math.Cos(0.00000000000+0.00000000000*Tau)
	L0 += 0.09260408252 * math.Cos(0.89106421530+74.78159856700*Tau)
	L0 += 0.01504247826 * math.Cos(3.62719262190+1.48447270830*Tau)
	L0 += 0.00365981718 * math.Cos(1.89962189070+73.29712585900*Tau)
	L0 += 0.00272328132 * math.Cos(3.35823710520+149.56319713000*Tau)
	L0 += 0.00070328499 * math.Cos(5.39254431990+63.73589830300*Tau)
	L0 += 0.00068892609 * math.Cos(6.09292489050+76.26607127600*Tau)
	L0 += 0.00061998592 * math.Cos(2.26952040470+2.96894541660*Tau)
	L0 += 0.00061950714 * math.Cos(2.85098907570+11.04570026400*Tau)
	L0 += 0.00026468869 * math.Cos(3.14152087890+71.81265315100*Tau)
	L0 += 0.00025710505 * math.Cos(6.11379842940+454.90936653000*Tau)
	L0 += 0.00021078897 * math.Cos(4.36059465140+148.07872443000*Tau)
	L0 += 0.00017818665 * math.Cos(1.74436982540+36.64856292900*Tau)
	L0 += 0.00014613471 * math.Cos(4.73732047980+3.93215326310*Tau)
	L0 += 0.00011162535 * math.Cos(5.82681993690+224.34479570000*Tau)
	L0 += 0.00010997934 * math.Cos(0.48865493179+138.51749687000*Tau)
	L0 += 0.00009527487 * math.Cos(2.95516893090+35.16409022100*Tau)
	L0 += 0.00007545543 * math.Cos(5.23626440670+109.94568879000*Tau)
	L0 += 0.00004220170 * math.Cos(3.23328535510+70.84944530400*Tau)
	L0 += 0.00004051850 * math.Cos(2.27754158720+151.04766984000*Tau)
	L0 += 0.00003490352 * math.Cos(5.48305567290+146.59425172000*Tau)
	L0 += 0.00003354607 * math.Cos(1.06549008890+4.45341812490*Tau)
	L0 += 0.00003144093 * math.Cos(4.75199307600+77.75054398400*Tau)
	L0 += 0.00002926671 * math.Cos(4.62903695490+9.56122755560*Tau)
	L0 += 0.00002922410 * math.Cos(5.35236743380+85.82729883100*Tau)
	L0 += 0.00002272790 * math.Cos(4.36600802760+70.32818044200*Tau)
	L0 += 0.00002148599 * math.Cos(0.60745800902+38.13303563800*Tau)
	L0 += 0.00002051209 * math.Cos(1.51773563460+0.11187458460*Tau)
	L0 += 0.00001991726 * math.Cos(4.92437290830+277.03499374000*Tau)
	L0 += 0.00001666910 * math.Cos(3.62744580850+380.12776796000*Tau)
	L0 += 0.00001533223 * math.Cos(2.58593414270+52.69019803900*Tau)
	L0 += 0.00001376208 * math.Cos(2.04281409050+65.22037101200*Tau)
	L0 += 0.00001372100 * math.Cos(4.19641615560+111.43016150000*Tau)
	L0 += 0.00001284183 * math.Cos(3.11346336880+202.25339517000*Tau)
	L0 += 0.00001281641 * math.Cos(0.54269869505+222.86032299000*Tau)
	L0 += 0.00001244342 * math.Cos(0.91612680579+2.44768055480*Tau)
	L0 += 0.00001220998 * math.Cos(0.19901396193+108.46121608000*Tau)
	L0 += 0.00001150993 * math.Cos(4.17898207050+33.67961751300*Tau)
	L0 += 0.00001150416 * math.Cos(0.93344454002+3.18139373770*Tau)
	L0 += 0.00001090461 * math.Cos(1.77501638910+12.53017297200*Tau)
	L0 += 0.00001072008 * math.Cos(0.23564502877+62.25142559500*Tau)
	L0 += 0.00000946195 * math.Cos(1.19249463070+127.47179661000*Tau)
	L0 += 0.00000707875 * math.Cos(5.18285226580+213.29909544000*Tau)
	L0 += 0.00000653401 * math.Cos(0.96586909116+78.71375183000*Tau)
	L0 += 0.00000627562 * math.Cos(0.18210181975+984.60033162000*Tau)
	L0 += 0.00000606827 * math.Cos(5.43209728950+529.69096509000*Tau)
	L0 += 0.00000559370 * math.Cos(3.35776737700+0.52126486180*Tau)
	L0 += 0.00000524495 * math.Cos(2.01276707000+299.12639427000*Tau)
	L0 += 0.00000483219 * math.Cos(2.10553990150+0.96320784650*Tau)
	L0 += 0.00000471288 * math.Cos(1.40664336450+184.72728736000*Tau)
	L0 += 0.00000467211 * math.Cos(0.41484068933+145.10977901000*Tau)
	L0 += 0.00000433532 * math.Cos(5.52142978260+183.24281465000*Tau)
	L0 += 0.00000404891 * math.Cos(5.98689011390+8.07675484730*Tau)
	L0 += 0.00000398996 * math.Cos(0.33810765436+415.55249061000*Tau)
	L0 += 0.00000395614 * math.Cos(5.87039580950+351.81659231000*Tau)
	L0 += 0.00000378609 * math.Cos(2.34975805010+56.62235130300*Tau)
	L0 += 0.00000309885 * math.Cos(5.83301304670+145.63104387000*Tau)
	L0 += 0.00000300379 * math.Cos(5.64353974150+22.09140052800*Tau)
	L0 += 0.00000294172 * math.Cos(5.83916826230+39.61750834600*Tau)
	L0 += 0.00000251792 * math.Cos(1.63696775580+221.37585029000*Tau)
	L0 += 0.00000249229 * math.Cos(4.74617120580+225.82926841000*Tau)
	L0 += 0.00000239334 * math.Cos(2.35045874710+137.03302416000*Tau)
	L0 += 0.00000224097 * math.Cos(0.51574863468+84.34282612300*Tau)
	L0 += 0.00000222588 * math.Cos(2.84309380330+0.26063243090*Tau)
	L0 += 0.00000219621 * math.Cos(1.92212987980+67.66805156700*Tau)
	L0 += 0.00000216549 * math.Cos(6.14211862700+5.93789083320*Tau)
	L0 += 0.00000216480 * math.Cos(4.77847481360+340.77089205000*Tau)
	L0 += 0.00000207828 * math.Cos(5.58020570040+68.84370773400*Tau)
	L0 += 0.00000201963 * math.Cos(1.29693040860+0.04818410980*Tau)
	L0 += 0.00000199146 * math.Cos(0.95634155010+152.53214255000*Tau)
	L0 += 0.00000193652 * math.Cos(1.88800122610+456.39383924000*Tau)
	L0 += 0.00000192998 * math.Cos(0.91616058506+453.42489382000*Tau)
	L0 += 0.00000187474 * math.Cos(1.31924326250+0.16005869440*Tau)
	L0 += 0.00000181934 * math.Cos(3.53624029240+79.23501669200*Tau)
	L0 += 0.00000173145 * math.Cos(1.53860728050+160.60889740000*Tau)
	L0 += 0.00000171968 * math.Cos(5.67952685530+219.89137758000*Tau)
	L0 += 0.00000170300 * math.Cos(3.67717520690+5.41662597140*Tau)
	L0 += 0.00000168648 * math.Cos(5.87874000880+18.15924726500*Tau)
	L0 += 0.00000164588 * math.Cos(1.42379714840+106.97674337000*Tau)
	L0 += 0.00000162792 * math.Cos(3.05029377670+112.91463421000*Tau)
	L0 += 0.00000158028 * math.Cos(0.73811997211+54.17467074800*Tau)
	L0 += 0.00000146653 * math.Cos(1.26300172260+59.80374504000*Tau)
	L0 += 0.00000143058 * math.Cos(1.29995487560+35.42472265200*Tau)
	L0 += 0.00000139453 * math.Cos(5.38597723400+32.19514480500*Tau)
	L0 += 0.00000138585 * math.Cos(4.25994786670+909.81873305000*Tau)
	L0 += 0.00000123840 * math.Cos(1.37359990340+7.11354700080*Tau)
	L0 += 0.00000110163 * math.Cos(2.02685778980+554.06998748000*Tau)
	L0 += 0.00000109376 * math.Cos(5.70581833290+77.96299230500*Tau)
	L0 += 0.00000104414 * math.Cos(5.02820888810+0.75075952540*Tau)
	L0 += 0.00000103562 * math.Cos(1.45770270250+24.37902238800*Tau)
	L0 += 0.00000103277 * math.Cos(0.68095301267+14.97785352700*Tau)

	L1 := 75.02543121600 * math.Cos(0.00000000000+0.00000000000*Tau)
	L1 += 0.00154458244 * math.Cos(5.24201658070+74.78159856700*Tau)
	L1 += 0.00024456413 * math.Cos(1.71255705310+1.48447270830*Tau)
	L1 += 0.00009257828 * math.Cos(0.42844639064+11.04570026400*Tau)
	L1 += 0.00008265977 * math.Cos(1.50220035110+63.73589830300*Tau)
	L1 += 0.00007841715 * math.Cos(1.31983607250+149.56319713000*Tau)
	L1 += 0.00003899105 * math.Cos(0.46483574024+3.93215326310*Tau)
	L1 += 0.00002283777 * math.Cos(4.17367534000+76.26607127600*Tau)
	L1 += 0.00001926600 * math.Cos(0.53013080152+2.96894541660*Tau)
	L1 += 0.00001232727 * math.Cos(1.58634458240+70.84944530400*Tau)
	L1 += 0.00000791206 * math.Cos(5.43641224140+3.18139373770*Tau)
	L1 += 0.00000766954 * math.Cos(1.99555409580+73.29712585900*Tau)
	L1 += 0.00000481671 * math.Cos(2.98401996910+85.82729883100*Tau)
	L1 += 0.00000449798 * math.Cos(4.13826237510+138.51749687000*Tau)
	L1 += 0.00000445600 * math.Cos(3.72300400330+224.34479570000*Tau)
	L1 += 0.00000426554 * math.Cos(4.73126059390+71.81265315100*Tau)
	L1 += 0.00000353752 * math.Cos(2.58324496890+148.07872443000*Tau)
	L1 += 0.00000347735 * math.Cos(2.45372261290+9.56122755560*Tau)
	L1 += 0.00000317084 * math.Cos(5.57855232070+52.69019803900*Tau)
	L1 += 0.00000205585 * math.Cos(2.36263144250+2.44768055480*Tau)
	L1 += 0.00000189068 * math.Cos(4.20242881380+56.62235130300*Tau)
	L1 += 0.00000183762 * math.Cos(0.28371004654+151.04766984000*Tau)
	L1 += 0.00000179920 * math.Cos(5.68367730920+12.53017297200*Tau)
	L1 += 0.00000171084 * math.Cos(3.00060075290+78.71375183000*Tau)
	L1 += 0.00000158029 * math.Cos(2.90931969500+0.96320784650*Tau)
	L1 += 0.00000154670 * math.Cos(5.59083925610+4.45341812490*Tau)
	L1 += 0.00000153515 * math.Cos(4.65186885940+35.16409022100*Tau)
	L1 += 0.00000151984 * math.Cos(2.94217326890+77.75054398400*Tau)
	L1 += 0.00000143464 * math.Cos(2.59049246730+62.25142559500*Tau)
	L1 += 0.00000121452 * math.Cos(4.14839204920+127.47179661000*Tau)
	L1 += 0.00000115546 * math.Cos(3.73224603790+65.22037101200*Tau)
	L1 += 0.00000102022 * math.Cos(4.18754517990+145.63104387000*Tau)
	L1 += 0.00000101718 * math.Cos(6.03385875010+0.11187458460*Tau)
	L1 += 0.00000088202 * math.Cos(3.99035787990+18.15924726500*Tau)
	L1 += 0.00000087549 * math.Cos(6.15520787580+202.25339517000*Tau)
	L1 += 0.00000080530 * math.Cos(2.64124743930+22.09140052800*Tau)
	L1 += 0.00000072047 * math.Cos(6.04545933580+70.32818044200*Tau)
	L1 += 0.00000068570 * math.Cos(4.05071895260+77.96299230500*Tau)
	L1 += 0.00000059173 * math.Cos(3.70413919080+67.66805156700*Tau)
	L1 += 0.00000047267 * math.Cos(3.54312460520+351.81659231000*Tau)
	L1 += 0.00000044339 * math.Cos(5.90865821910+7.11354700080*Tau)
	L1 += 0.00000042534 * math.Cos(5.72357370900+5.41662597140*Tau)
	L1 += 0.00000038544 * math.Cos(4.91519003850+222.86032299000*Tau)
	L1 += 0.00000036116 * math.Cos(5.89964278800+33.67961751300*Tau)
	L1 += 0.00000035605 * math.Cos(3.29197259180+8.07675484730*Tau)
	L1 += 0.00000035524 * math.Cos(3.32784616140+71.60020483000*Tau)
	L1 += 0.00000034996 * math.Cos(5.08034112150+38.13303563800*Tau)
	L1 += 0.00000031454 * math.Cos(5.62015632300+984.60033162000*Tau)
	L1 += 0.00000030811 * math.Cos(5.49591403860+59.80374504000*Tau)
	L1 += 0.00000030608 * math.Cos(5.46414592600+160.60889740000*Tau)
	L1 += 0.00000029866 * math.Cos(1.65980844670+447.79581953000*Tau)
	L1 += 0.00000029206 * math.Cos(1.14722640420+462.02291353000*Tau)
	L1 += 0.00000028947 * math.Cos(4.51867390410+84.34282612300*Tau)
	L1 += 0.00000026627 * math.Cos(5.54127301040+131.40394987000*Tau)
	L1 += 0.00000026605 * math.Cos(6.14640604130+299.12639427000*Tau)
	L1 += 0.00000025753 * math.Cos(4.99362028420+137.03302416000*Tau)
	L1 += 0.00000025373 * math.Cos(5.73584678600+380.12776796000*Tau)

	L2 := 0.00053033277 * math.Cos(0.00000000000+0.00000000000*Tau)
	L2 += 0.00002357636 * math.Cos(2.26014661700+74.78159856700*Tau)
	L2 += 0.00000769129 * math.Cos(4.52561041820+11.04570026400*Tau)
	L2 += 0.00000551533 * math.Cos(3.25814281020+63.73589830300*Tau)
	L2 += 0.00000541532 * math.Cos(2.27573907420+3.93215326310*Tau)
	L2 += 0.00000529473 * math.Cos(4.92348433830+1.48447270830*Tau)
	L2 += 0.00000257521 * math.Cos(3.69059216860+3.18139373770*Tau)
	L2 += 0.00000238835 * math.Cos(5.85806638400+149.56319713000*Tau)
	L2 += 0.00000181904 * math.Cos(6.21763603410+70.84944530400*Tau)
	L2 += 0.00000053504 * math.Cos(1.44225240950+76.26607127600*Tau)
	L2 += 0.00000049401 * math.Cos(6.03101301720+56.62235130300*Tau)
	L2 += 0.00000044753 * math.Cos(3.90904910520+2.44768055480*Tau)
	L2 += 0.00000044530 * math.Cos(0.81152639478+85.82729883100*Tau)
	L2 += 0.00000038222 * math.Cos(1.78467827780+52.69019803900*Tau)
	L2 += 0.00000037403 * math.Cos(4.46228598030+2.96894541660*Tau)
	L2 += 0.00000033029 * math.Cos(0.86388149962+9.56122755560*Tau)
	L2 += 0.00000029423 * math.Cos(5.09818697710+73.29712585900*Tau)
	L2 += 0.00000024292 * math.Cos(2.10702559050+18.15924726500*Tau)
	L2 += 0.00000022491 * math.Cos(5.99320728690+138.51749687000*Tau)
	L2 += 0.00000022135 * math.Cos(4.81730808580+78.71375183000*Tau)
	L2 += 0.00000021392 * math.Cos(2.39880709310+77.96299230500*Tau)
	L2 += 0.00000020578 * math.Cos(2.16918786540+224.34479570000*Tau)
	L2 += 0.00000017226 * math.Cos(2.53537183200+145.63104387000*Tau)
	L2 += 0.00000016777 * math.Cos(3.46631344090+12.53017297200*Tau)
	L2 += 0.00000012012 * math.Cos(0.01941361902+22.09140052800*Tau)
	L2 += 0.00000011010 * math.Cos(0.08496274370+127.47179661000*Tau)
	L2 += 0.00000010476 * math.Cos(5.16453084070+71.60020483000*Tau)
	L2 += 0.00000010466 * math.Cos(4.45556032590+62.25142559500*Tau)
	L2 += 0.00000008668 * math.Cos(4.25550086980+7.11354700080*Tau)
	L2 += 0.00000008387 * math.Cos(5.50115930050+67.66805156700*Tau)
	L2 += 0.00000007160 * math.Cos(1.24903906390+5.41662597140*Tau)
	L2 += 0.00000006109 * math.Cos(3.36320161280+447.79581953000*Tau)
	L2 += 0.00000006087 * math.Cos(5.44611674380+65.22037101200*Tau)
	L2 += 0.00000006013 * math.Cos(4.51836836350+151.04766984000*Tau)
	L2 += 0.00000006003 * math.Cos(5.72500086740+462.02291353000*Tau)

	L3 := 0.00000120936 * math.Cos(0.02418789918+74.78159856700*Tau)
	L3 += 0.00000068064 * math.Cos(4.12084267730+3.93215326310*Tau)
	L3 += 0.00000052828 * math.Cos(2.38964061260+11.04570026400*Tau)
	L3 += 0.00000045806 * math.Cos(0.00000000000+0.00000000000*Tau)
	L3 += 0.00000045300 * math.Cos(2.04423798410+3.18139373770*Tau)
	L3 += 0.00000043754 * math.Cos(2.95965039730+1.48447270830*Tau)
	L3 += 0.00000024969 * math.Cos(4.88741307920+63.73589830300*Tau)
	L3 += 0.00000021061 * math.Cos(4.54511486860+70.84944530400*Tau)
	L3 += 0.00000019897 * math.Cos(2.31320314140+149.56319713000*Tau)
	L3 += 0.00000008901 * math.Cos(1.57548871760+56.62235130300*Tau)
	L3 += 0.00000004271 * math.Cos(0.22777319552+18.15924726500*Tau)
	L3 += 0.00000003613 * math.Cos(5.39244611310+76.26607127600*Tau)
	L3 += 0.00000003572 * math.Cos(0.95052448578+77.96299230500*Tau)
	L3 += 0.00000003488 * math.Cos(4.97622811780+85.82729883100*Tau)
	L3 += 0.00000003479 * math.Cos(4.12969359980+52.69019803900*Tau)
	L3 += 0.00000002696 * math.Cos(0.37287796344+78.71375183000*Tau)
	L3 += 0.00000002328 * math.Cos(0.85770961794+145.63104387000*Tau)
	L3 += 0.00000002156 * math.Cos(5.65647821520+9.56122755560*Tau)

	L4 := 0.00000113855 * math.Cos(3.14159265360+0.00000000000*Tau)
	L4 += 0.00000005599 * math.Cos(4.57882424420+74.78159856700*Tau)
	L4 += 0.00000003203 * math.Cos(0.34623003207+11.04570026400*Tau)
	L4 += 0.00000001217 * math.Cos(3.42199121830+56.62235130300*Tau)

	L5 := 0.00000000000

	return L0 + L1*Tau + L2*Tau2 + L3*Tau3 + L4*Tau4 + L5*Tau5
}

func _GetLatitudeUranus(Tau, Tau2, Tau3, Tau4, Tau5 float64) float64 {
	B0 := 0.01346277639 * math.Cos(2.61877810550+74.78159856700*Tau)
	B0 += 0.00062341405 * math.Cos(5.08111175860+149.56319713000*Tau)
	B0 += 0.00061601203 * math.Cos(3.14159265360+0.00000000000*Tau)
	B0 += 0.00009963744 * math.Cos(1.61603876360+76.26607127600*Tau)
	B0 += 0.00009926151 * math.Cos(0.57630387917+73.29712585900*Tau)
	B0 += 0.00003259455 * math.Cos(1.26119385960+224.34479570000*Tau)
	B0 += 0.00002972318 * math.Cos(2.24367035540+1.48447270830*Tau)
	B0 += 0.00002010257 * math.Cos(6.05550401090+148.07872443000*Tau)
	B0 += 0.00001522172 * math.Cos(0.27960386377+63.73589830300*Tau)
	B0 += 0.00000924055 * math.Cos(4.03822927850+151.04766984000*Tau)
	B0 += 0.00000760624 * math.Cos(6.14000431920+71.81265315100*Tau)
	B0 += 0.00000522309 * math.Cos(3.32085194770+138.51749687000*Tau)
	B0 += 0.00000462630 * math.Cos(0.74256727574+85.82729883100*Tau)
	B0 += 0.00000436843 * math.Cos(3.38082524320+529.69096509000*Tau)
	B0 += 0.00000434625 * math.Cos(0.34065281858+77.75054398400*Tau)
	B0 += 0.00000430668 * math.Cos(3.55445034850+213.29909544000*Tau)
	B0 += 0.00000420265 * math.Cos(5.21279984790+11.04570026400*Tau)
	B0 += 0.00000244698 * math.Cos(0.78795150326+2.96894541660*Tau)
	B0 += 0.00000232649 * math.Cos(2.25716421380+222.86032299000*Tau)
	B0 += 0.00000215838 * math.Cos(1.59121704940+38.13303563800*Tau)
	B0 += 0.00000179935 * math.Cos(3.72487952670+299.12639427000*Tau)
	B0 += 0.00000174895 * math.Cos(1.23550262210+146.59425172000*Tau)
	B0 += 0.00000173667 * math.Cos(1.93654269130+380.12776796000*Tau)
	B0 += 0.00000160368 * math.Cos(5.33635436460+111.43016150000*Tau)
	B0 += 0.00000144064 * math.Cos(5.96239326410+35.16409022100*Tau)
	B0 += 0.00000116363 * math.Cos(5.73877190010+70.84944530400*Tau)
	B0 += 0.00000106441 * math.Cos(0.94103112994+70.32818044200*Tau)
	B0 += 0.00000102049 * math.Cos(2.61876256510+78.71375183000*Tau)

	B1 := 0.00206366162 * math.Cos(4.12394311410+74.78159856700*Tau)
	B1 += 0.00008563230 * math.Cos(0.33819986165+149.56319713000*Tau)
	B1 += 0.00001725703 * math.Cos(2.12193159900+73.29712585900*Tau)
	B1 += 0.00001374449 * math.Cos(0.00000000000+0.00000000000*Tau)
	B1 += 0.00001368860 * math.Cos(3.06861722050+76.26607127600*Tau)
	B1 += 0.00000450639 * math.Cos(3.77656180980+1.48447270830*Tau)
	B1 += 0.00000399847 * math.Cos(2.84767037790+224.34479570000*Tau)
	B1 += 0.00000307214 * math.Cos(1.25456766740+148.07872443000*Tau)
	B1 += 0.00000154336 * math.Cos(3.78575467750+63.73589830300*Tau)
	B1 += 0.00000112432 * math.Cos(5.57299891500+151.04766984000*Tau)
	B1 += 0.00000110888 * math.Cos(5.32888676460+138.51749687000*Tau)
	B1 += 0.00000083493 * math.Cos(3.59152795560+71.81265315100*Tau)
	B1 += 0.00000055573 * math.Cos(3.40135416350+85.82729883100*Tau)
	B1 += 0.00000053690 * math.Cos(1.70455769940+77.75054398400*Tau)
	B1 += 0.00000041912 * math.Cos(1.21476607430+11.04570026400*Tau)
	B1 += 0.00000041377 * math.Cos(4.45476669140+78.71375183000*Tau)
	B1 += 0.00000031959 * math.Cos(3.77446207750+222.86032299000*Tau)
	B1 += 0.00000030297 * math.Cos(2.56371683640+2.96894541660*Tau)
	B1 += 0.00000026977 * math.Cos(5.33695500290+213.29909544000*Tau)
	B1 += 0.00000026222 * math.Cos(0.41620628369+380.12776796000*Tau)

	B2 := 0.00009211656 * math.Cos(5.80044305790+74.78159856700*Tau)
	B2 += 0.00000556926 * math.Cos(0.00000000000+0.00000000000*Tau)
	B2 += 0.00000286265 * math.Cos(2.17729776350+149.56319713000*Tau)
	B2 += 0.00000094969 * math.Cos(3.84237569810+73.29712585900*Tau)
	B2 += 0.00000045419 * math.Cos(4.87822046060+76.26607127600*Tau)
	B2 += 0.00000020107 * math.Cos(5.46264485370+1.48447270830*Tau)
	B2 += 0.00000014793 * math.Cos(0.87983715652+138.51749687000*Tau)
	B2 += 0.00000014261 * math.Cos(2.84517742690+148.07872443000*Tau)
	B2 += 0.00000013963 * math.Cos(5.07234043990+63.73589830300*Tau)
	B2 += 0.00000010122 * math.Cos(5.00290894860+224.34479570000*Tau)
	B2 += 0.00000008299 * math.Cos(6.26655615200+78.71375183000*Tau)

	B3 := 0.00000267832 * math.Cos(1.25097888290+74.78159856700*Tau)
	B3 += 0.00000011048 * math.Cos(3.14159265360+0.00000000000*Tau)
	B3 += 0.00000006154 * math.Cos(4.00663614490+149.56319713000*Tau)
	B3 += 0.00000003361 * math.Cos(5.77804694940+73.29712585900*Tau)

	B4 := 0.00000005719 * math.Cos(2.85499529310+74.78159856700*Tau)

	B5 := 0.00000000000

	return B0 + B1*Tau + B2*Tau2 + B3*Tau3 + B4*Tau4 + B5*Tau5
}

func _GetRadiusVectorUranus(Tau, Tau2, Tau3, Tau4, Tau5 float64) float64 {
	R0 := 19.21264847900 * math.Cos(0.00000000000+0.00000000000*Tau)
	R0 += 0.88784984055 * math.Cos(5.60377526990+74.78159856700*Tau)
	R0 += 0.03440835545 * math.Cos(0.32836098991+73.29712585900*Tau)
	R0 += 0.02055653495 * math.Cos(1.78295170030+149.56319713000*Tau)
	R0 += 0.00649321851 * math.Cos(4.52247298120+76.26607127600*Tau)
	R0 += 0.00602248144 * math.Cos(3.86003820460+63.73589830300*Tau)
	R0 += 0.00496404171 * math.Cos(1.40139934720+454.90936653000*Tau)
	R0 += 0.00338525522 * math.Cos(1.58002682950+138.51749687000*Tau)
	R0 += 0.00243508222 * math.Cos(1.57086595070+71.81265315100*Tau)
	R0 += 0.00190521915 * math.Cos(1.99809364500+1.48447270830*Tau)
	R0 += 0.00161858251 * math.Cos(2.79137863470+148.07872443000*Tau)
	R0 += 0.00143705902 * math.Cos(1.38368574480+11.04570026400*Tau)
	R0 += 0.00093192359 * math.Cos(0.17437193645+36.64856292900*Tau)
	R0 += 0.00089805842 * math.Cos(3.66105366330+109.94568879000*Tau)
	R0 += 0.00071424265 * math.Cos(4.24509327400+224.34479570000*Tau)
	R0 += 0.00046677322 * math.Cos(1.39976563940+35.16409022100*Tau)
	R0 += 0.00039025681 * math.Cos(3.36234710690+277.03499374000*Tau)
	R0 += 0.00039009624 * math.Cos(1.66971128870+70.84944530400*Tau)
	R0 += 0.00036755160 * math.Cos(3.88648934740+146.59425172000*Tau)
	R0 += 0.00030348875 * math.Cos(0.70100446346+151.04766984000*Tau)
	R0 += 0.00029156264 * math.Cos(3.18056174560+77.75054398400*Tau)
	R0 += 0.00025785805 * math.Cos(3.78537741500+85.82729883100*Tau)
	R0 += 0.00025620360 * math.Cos(5.25656292800+380.12776796000*Tau)
	R0 += 0.00022637152 * math.Cos(0.72519137745+529.69096509000*Tau)
	R0 += 0.00020473163 * math.Cos(2.79639811630+70.32818044200*Tau)
	R0 += 0.00020471584 * math.Cos(1.55588961500+202.25339517000*Tau)
	R0 += 0.00017900561 * math.Cos(0.55455488605+2.96894541660*Tau)
	R0 += 0.00015502809 * math.Cos(5.35405037600+38.13303563800*Tau)
	R0 += 0.00014701566 * math.Cos(4.90434406650+108.46121608000*Tau)
	R0 += 0.00012896507 * math.Cos(2.62154018240+111.43016150000*Tau)
	R0 += 0.00012328151 * math.Cos(5.96039150920+127.47179661000*Tau)
	R0 += 0.00011959355 * math.Cos(1.75044072170+984.60033162000*Tau)
	R0 += 0.00011852996 * math.Cos(0.99342814582+52.69019803900*Tau)
	R0 += 0.00011696085 * math.Cos(3.29825599110+3.93215326310*Tau)
	R0 += 0.00011494701 * math.Cos(0.43774027872+65.22037101200*Tau)
	R0 += 0.00010792699 * math.Cos(1.42104858470+213.29909544000*Tau)
	R0 += 0.00009111446 * math.Cos(4.99638600050+62.25142559500*Tau)
	R0 += 0.00008420550 * math.Cos(5.25350716620+222.86032299000*Tau)
	R0 += 0.00008402147 * math.Cos(5.03877516490+415.55249061000*Tau)
	R0 += 0.00007449125 * math.Cos(0.79491905956+351.81659231000*Tau)
	R0 += 0.00007329454 * math.Cos(3.97277527840+183.24281465000*Tau)
	R0 += 0.00006046370 * math.Cos(5.67960948360+78.71375183000*Tau)
	R0 += 0.00005524133 * math.Cos(3.11499484160+9.56122755560*Tau)
	R0 += 0.00005444878 * math.Cos(5.10575635360+145.10977901000*Tau)
	R0 += 0.00005238103 * math.Cos(2.62960141800+33.67961751300*Tau)
	R0 += 0.00004079167 * math.Cos(3.22064788670+340.77089205000*Tau)
	R0 += 0.00003919476 * math.Cos(4.25015288870+39.61750834600*Tau)
	R0 += 0.00003801606 * math.Cos(6.10985558500+184.72728736000*Tau)
	R0 += 0.00003781219 * math.Cos(3.45840272870+456.39383924000*Tau)
	R0 += 0.00003686787 * math.Cos(2.48718116540+453.42489382000*Tau)
	R0 += 0.00003101743 * math.Cos(4.14031063900+219.89137758000*Tau)
	R0 += 0.00002962641 * math.Cos(0.82977991995+56.62235130300*Tau)
	R0 += 0.00002942239 * math.Cos(0.42393808854+299.12639427000*Tau)
	R0 += 0.00002940492 * math.Cos(2.14637460320+137.03302416000*Tau)
	R0 += 0.00002937799 * math.Cos(3.67657450930+140.00196958000*Tau)
	R0 += 0.00002865128 * math.Cos(0.30996903761+12.53017297200*Tau)
	R0 += 0.00002538032 * math.Cos(4.85457831990+131.40394987000*Tau)
	R0 += 0.00002363550 * math.Cos(0.44253328372+554.06998748000*Tau)
	R0 += 0.00002182572 * math.Cos(2.94040431640+305.34616939000*Tau)

	R1 := 0.01479896370 * math.Cos(3.67205705320+74.78159856700*Tau)
	R1 += 0.00071212085 * math.Cos(6.22601006670+63.73589830300*Tau)
	R1 += 0.00068626972 * math.Cos(6.13411265050+149.56319713000*Tau)
	R1 += 0.00024059649 * math.Cos(3.14159265360+0.00000000000*Tau)
	R1 += 0.00021468152 * math.Cos(2.60176704270+76.26607127600*Tau)
	R1 += 0.00020857262 * math.Cos(5.24625494220+11.04570026400*Tau)
	R1 += 0.00011405346 * math.Cos(0.01848461561+70.84944530400*Tau)
	R1 += 0.00007496775 * math.Cos(0.42360033283+73.29712585900*Tau)
	R1 += 0.00004243800 * math.Cos(1.41692350370+85.82729883100*Tau)
	R1 += 0.00003926694 * math.Cos(3.15513991320+71.81265315100*Tau)
	R1 += 0.00003578446 * math.Cos(2.31160668310+224.34479570000*Tau)
	R1 += 0.00003505936 * math.Cos(2.58354048850+138.51749687000*Tau)
	R1 += 0.00003228835 * math.Cos(5.25499602900+3.93215326310*Tau)
	R1 += 0.00003060010 * math.Cos(0.15321893225+1.48447270830*Tau)
	R1 += 0.00002564251 * math.Cos(0.98076846352+148.07872443000*Tau)
	R1 += 0.00002429445 * math.Cos(3.99440122470+52.69019803900*Tau)
	R1 += 0.00001644719 * math.Cos(2.65349313120+127.47179661000*Tau)
	R1 += 0.00001583766 * math.Cos(1.43045619200+78.71375183000*Tau)
	R1 += 0.00001508028 * math.Cos(5.05996325430+151.04766984000*Tau)
	R1 += 0.00001489525 * math.Cos(2.67559167320+56.62235130300*Tau)
	R1 += 0.00001413112 * math.Cos(4.57461892060+202.25339517000*Tau)
	R1 += 0.00001403237 * math.Cos(1.36985349740+77.75054398400*Tau)
	R1 += 0.00001228220 * math.Cos(1.04703640150+62.25142559500*Tau)
	R1 += 0.00001032731 * math.Cos(0.26459059027+131.40394987000*Tau)
	R1 += 0.00000992085 * math.Cos(2.17168865910+65.22037101200*Tau)
	R1 += 0.00000861867 * math.Cos(5.05530802220+351.81659231000*Tau)
	R1 += 0.00000744445 * math.Cos(3.07640148940+35.16409022100*Tau)
	R1 += 0.00000687470 * math.Cos(2.49912565670+77.96299230500*Tau)
	R1 += 0.00000646851 * math.Cos(4.47290422910+70.32818044200*Tau)
	R1 += 0.00000623602 * math.Cos(0.86253073820+9.56122755560*Tau)
	R1 += 0.00000604362 * math.Cos(0.90717667985+984.60033162000*Tau)
	R1 += 0.00000574710 * math.Cos(3.23070708460+447.79581953000*Tau)
	R1 += 0.00000561839 * math.Cos(2.71778158980+462.02291353000*Tau)
	R1 += 0.00000530364 * math.Cos(5.91655309050+213.29909544000*Tau)
	R1 += 0.00000527794 * math.Cos(5.15136007080+2.96894541660*Tau)

	R2 := 0.00022439904 * math.Cos(0.69953118760+74.78159856700*Tau)
	R2 += 0.00004727037 * math.Cos(1.69901641490+63.73589830300*Tau)
	R2 += 0.00001681903 * math.Cos(4.64833551730+70.84944530400*Tau)
	R2 += 0.00001649559 * math.Cos(3.09660078980+11.04570026400*Tau)
	R2 += 0.00001433755 * math.Cos(3.52119917950+149.56319713000*Tau)
	R2 += 0.00000770188 * math.Cos(0.00000000000+0.00000000000*Tau)
	R2 += 0.00000500429 * math.Cos(6.17229032220+76.26607127600*Tau)
	R2 += 0.00000461009 * math.Cos(0.76676632849+3.93215326310*Tau)
	R2 += 0.00000390371 * math.Cos(4.49605283500+56.62235130300*Tau)
	R2 += 0.00000389945 * math.Cos(5.52673426380+85.82729883100*Tau)
	R2 += 0.00000292097 * math.Cos(0.20389012095+52.69019803900*Tau)
	R2 += 0.00000286579 * math.Cos(3.53357683270+73.29712585900*Tau)
	R2 += 0.00000272898 * math.Cos(3.84707823650+138.51749687000*Tau)
	R2 += 0.00000219674 * math.Cos(1.96418942890+131.40394987000*Tau)
	R2 += 0.00000215788 * math.Cos(0.84812474187+77.96299230500*Tau)
	R2 += 0.00000205449 * math.Cos(3.24758017120+78.71375183000*Tau)
	R2 += 0.00000148554 * math.Cos(4.89840863840+127.47179661000*Tau)
	R2 += 0.00000128834 * math.Cos(2.08146849520+3.18139373770*Tau)

	R3 := 0.00001164382 * math.Cos(4.73453291600+74.78159856700*Tau)
	R3 += 0.00000212367 * math.Cos(3.34255735000+63.73589830300*Tau)
	R3 += 0.00000196408 * math.Cos(2.98004616320+70.84944530400*Tau)
	R3 += 0.00000104527 * math.Cos(0.95807937648+11.04570026400*Tau)
	R3 += 0.00000072540 * math.Cos(0.99701907912+149.56319713000*Tau)
	R3 += 0.00000071681 * math.Cos(0.02528455665+56.62235130300*Tau)
	R3 += 0.00000054875 * math.Cos(2.59436811270+3.93215326310*Tau)
	R3 += 0.00000036377 * math.Cos(5.65035573020+77.96299230500*Tau)
	R3 += 0.00000034029 * math.Cos(3.81553325640+76.26607127600*Tau)
	R3 += 0.00000032081 * math.Cos(3.59825177840+131.40394987000*Tau)

	R4 := 0.00000052996 * math.Cos(3.00838033090+74.78159856700*Tau)
	R4 += 0.00000009887 * math.Cos(1.91399083600+56.62235130300*Tau)

	R5 := 0.00000000000

	return R0 + R1*Tau + R2*Tau2 + R3*Tau3 + R4*Tau4 + R5*Tau5
}

// ComputeUranus
func ComputeUranus(JD float64) TStEclipticalCord {
	var (
		Tau, Tau2, Tau3, Tau4, Tau5 float64
		Result                      TStEclipticalCord
	)
	Tau = (JD - 2451545.0) / 365250.0
	Tau2 = common.Sqr(Tau)
	Tau3 = Tau * Tau2
	Tau4 = common.Sqr(Tau2)
	Tau5 = Tau2 * Tau3

	Result.L0 = _GetLongitudeUranus(Tau, Tau2, Tau3, Tau4, Tau5)
	Result.B0 = _GetLatitudeUranus(Tau, Tau2, Tau3, Tau4, Tau5)
	Result.R0 = _GetRadiusVectorUranus(Tau, Tau2, Tau3, Tau4, Tau5)
	return Result
} // ComputeUranus
